﻿Imports System.IO
Imports System.Net
Imports System.Text

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub FTPUpload(sender As Object, e As EventArgs)
        'FTP Server URL.
        Dim ftp As String = "ftp://yourserver.com/"

        'FTP Folder name. Leave blank if you want to upload to root folder.
        Dim ftpFolder As String = "Uploads/"

        Dim fileBytes As Byte() = Nothing

        'Read the FileName and convert it to Byte array.
        Dim fileName As String = Path.GetFileName(FileUpload1.FileName)
        Using fileStream As New StreamReader(FileUpload1.PostedFile.InputStream)
            fileBytes = Encoding.UTF8.GetBytes(fileStream.ReadToEnd())
            fileStream.Close()
        End Using

        Try
            'Create FTP Request.
            Dim request As FtpWebRequest = DirectCast(WebRequest.Create(ftp & ftpFolder & fileName), FtpWebRequest)
            request.Method = WebRequestMethods.Ftp.UploadFile

            'Enter FTP Server credentials.
            request.Credentials = New NetworkCredential("UserName", "Password")
            request.ContentLength = fileBytes.Length
            request.UsePassive = True
            request.UseBinary = True
            request.ServicePoint.ConnectionLimit = fileBytes.Length
            request.EnableSsl = False

            Using requestStream As Stream = request.GetRequestStream()
                requestStream.Write(fileBytes, 0, fileBytes.Length)
                requestStream.Close()
            End Using

            Dim response As FtpWebResponse = DirectCast(request.GetResponse(), FtpWebResponse)

            lblMessage.Text &= fileName & " uploaded.<br />"
            response.Close()
        Catch ex As WebException
            Throw New Exception(TryCast(ex.Response, FtpWebResponse).StatusDescription)
        End Try
    End Sub
End Class
